Index: XIOS3/trunk/src/interface/c_attr/icfile_attr.cpp
===================================================================
--- XIOS3/trunk/src/interface/c_attr/icfile_attr.cpp	(revision 2614)
+++ XIOS3/trunk/src/interface/c_attr/icfile_attr.cpp	(revision 2616)
@@ -239,4 +239,30 @@
 
 
+  void cxios_set_file_gatherer(file_Ptr file_hdl, const char * gatherer, int gatherer_size)
+  {
+    std::string gatherer_str;
+    if (!cstr2string(gatherer, gatherer_size, gatherer_str)) return;
+    CTimer::get("XIOS").resume();
+    file_hdl->gatherer.setValue(gatherer_str);
+    CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_file_gatherer(file_Ptr file_hdl, char * gatherer, int gatherer_size)
+  {
+    CTimer::get("XIOS").resume();
+    if (!string_copy(file_hdl->gatherer.getInheritedValue(), gatherer, gatherer_size))
+      ERROR("void cxios_get_file_gatherer(file_Ptr file_hdl, char * gatherer, int gatherer_size)", << "Input string is too short");
+    CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_file_gatherer(file_Ptr file_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = file_hdl->gatherer.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
   void cxios_set_file_min_digits(file_Ptr file_hdl, int min_digits)
   {
@@ -427,4 +453,82 @@
 
 
+  void cxios_set_file_pool_gatherer(file_Ptr file_hdl, const char * pool_gatherer, int pool_gatherer_size)
+  {
+    std::string pool_gatherer_str;
+    if (!cstr2string(pool_gatherer, pool_gatherer_size, pool_gatherer_str)) return;
+    CTimer::get("XIOS").resume();
+    file_hdl->pool_gatherer.setValue(pool_gatherer_str);
+    CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_file_pool_gatherer(file_Ptr file_hdl, char * pool_gatherer, int pool_gatherer_size)
+  {
+    CTimer::get("XIOS").resume();
+    if (!string_copy(file_hdl->pool_gatherer.getInheritedValue(), pool_gatherer, pool_gatherer_size))
+      ERROR("void cxios_get_file_pool_gatherer(file_Ptr file_hdl, char * pool_gatherer, int pool_gatherer_size)", << "Input string is too short");
+    CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_file_pool_gatherer(file_Ptr file_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = file_hdl->pool_gatherer.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
+  void cxios_set_file_pool_reader(file_Ptr file_hdl, const char * pool_reader, int pool_reader_size)
+  {
+    std::string pool_reader_str;
+    if (!cstr2string(pool_reader, pool_reader_size, pool_reader_str)) return;
+    CTimer::get("XIOS").resume();
+    file_hdl->pool_reader.setValue(pool_reader_str);
+    CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_file_pool_reader(file_Ptr file_hdl, char * pool_reader, int pool_reader_size)
+  {
+    CTimer::get("XIOS").resume();
+    if (!string_copy(file_hdl->pool_reader.getInheritedValue(), pool_reader, pool_reader_size))
+      ERROR("void cxios_get_file_pool_reader(file_Ptr file_hdl, char * pool_reader, int pool_reader_size)", << "Input string is too short");
+    CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_file_pool_reader(file_Ptr file_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = file_hdl->pool_reader.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
+  void cxios_set_file_pool_writer(file_Ptr file_hdl, const char * pool_writer, int pool_writer_size)
+  {
+    std::string pool_writer_str;
+    if (!cstr2string(pool_writer, pool_writer_size, pool_writer_str)) return;
+    CTimer::get("XIOS").resume();
+    file_hdl->pool_writer.setValue(pool_writer_str);
+    CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_file_pool_writer(file_Ptr file_hdl, char * pool_writer, int pool_writer_size)
+  {
+    CTimer::get("XIOS").resume();
+    if (!string_copy(file_hdl->pool_writer.getInheritedValue(), pool_writer, pool_writer_size))
+      ERROR("void cxios_get_file_pool_writer(file_Ptr file_hdl, char * pool_writer, int pool_writer_size)", << "Input string is too short");
+    CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_file_pool_writer(file_Ptr file_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = file_hdl->pool_writer.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
   void cxios_set_file_read_metadata_par(file_Ptr file_hdl, bool read_metadata_par)
   {
@@ -445,4 +549,30 @@
      CTimer::get("XIOS").resume();
      bool isDefined = file_hdl->read_metadata_par.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
+  void cxios_set_file_reader(file_Ptr file_hdl, const char * reader, int reader_size)
+  {
+    std::string reader_str;
+    if (!cstr2string(reader, reader_size, reader_str)) return;
+    CTimer::get("XIOS").resume();
+    file_hdl->reader.setValue(reader_str);
+    CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_file_reader(file_Ptr file_hdl, char * reader, int reader_size)
+  {
+    CTimer::get("XIOS").resume();
+    if (!string_copy(file_hdl->reader.getInheritedValue(), reader, reader_size))
+      ERROR("void cxios_get_file_reader(file_Ptr file_hdl, char * reader, int reader_size)", << "Input string is too short");
+    CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_file_reader(file_Ptr file_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = file_hdl->reader.hasInheritedValue();
      CTimer::get("XIOS").suspend();
      return isDefined;
@@ -885,4 +1015,27 @@
 
 
+  void cxios_set_file_using_server2(file_Ptr file_hdl, bool using_server2)
+  {
+    CTimer::get("XIOS").resume();
+    file_hdl->using_server2.setValue(using_server2);
+    CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_file_using_server2(file_Ptr file_hdl, bool* using_server2)
+  {
+    CTimer::get("XIOS").resume();
+    *using_server2 = file_hdl->using_server2.getInheritedValue();
+    CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_file_using_server2(file_Ptr file_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = file_hdl->using_server2.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
   void cxios_set_file_uuid_format(file_Ptr file_hdl, const char * uuid_format, int uuid_format_size)
   {
@@ -935,3 +1088,29 @@
      return isDefined;
   }
+
+
+  void cxios_set_file_writer(file_Ptr file_hdl, const char * writer, int writer_size)
+  {
+    std::string writer_str;
+    if (!cstr2string(writer, writer_size, writer_str)) return;
+    CTimer::get("XIOS").resume();
+    file_hdl->writer.setValue(writer_str);
+    CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_file_writer(file_Ptr file_hdl, char * writer, int writer_size)
+  {
+    CTimer::get("XIOS").resume();
+    if (!string_copy(file_hdl->writer.getInheritedValue(), writer, writer_size))
+      ERROR("void cxios_get_file_writer(file_Ptr file_hdl, char * writer, int writer_size)", << "Input string is too short");
+    CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_file_writer(file_Ptr file_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = file_hdl->writer.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
 }
Index: XIOS3/trunk/src/interface/c_attr/icfilegroup_attr.cpp
===================================================================
--- XIOS3/trunk/src/interface/c_attr/icfilegroup_attr.cpp	(revision 2614)
+++ XIOS3/trunk/src/interface/c_attr/icfilegroup_attr.cpp	(revision 2616)
@@ -239,4 +239,30 @@
 
 
+  void cxios_set_filegroup_gatherer(filegroup_Ptr filegroup_hdl, const char * gatherer, int gatherer_size)
+  {
+    std::string gatherer_str;
+    if (!cstr2string(gatherer, gatherer_size, gatherer_str)) return;
+    CTimer::get("XIOS").resume();
+    filegroup_hdl->gatherer.setValue(gatherer_str);
+    CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_filegroup_gatherer(filegroup_Ptr filegroup_hdl, char * gatherer, int gatherer_size)
+  {
+    CTimer::get("XIOS").resume();
+    if (!string_copy(filegroup_hdl->gatherer.getInheritedValue(), gatherer, gatherer_size))
+      ERROR("void cxios_get_filegroup_gatherer(filegroup_Ptr filegroup_hdl, char * gatherer, int gatherer_size)", << "Input string is too short");
+    CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_filegroup_gatherer(filegroup_Ptr filegroup_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = filegroup_hdl->gatherer.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
   void cxios_set_filegroup_group_ref(filegroup_Ptr filegroup_hdl, const char * group_ref, int group_ref_size)
   {
@@ -453,4 +479,82 @@
 
 
+  void cxios_set_filegroup_pool_gatherer(filegroup_Ptr filegroup_hdl, const char * pool_gatherer, int pool_gatherer_size)
+  {
+    std::string pool_gatherer_str;
+    if (!cstr2string(pool_gatherer, pool_gatherer_size, pool_gatherer_str)) return;
+    CTimer::get("XIOS").resume();
+    filegroup_hdl->pool_gatherer.setValue(pool_gatherer_str);
+    CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_filegroup_pool_gatherer(filegroup_Ptr filegroup_hdl, char * pool_gatherer, int pool_gatherer_size)
+  {
+    CTimer::get("XIOS").resume();
+    if (!string_copy(filegroup_hdl->pool_gatherer.getInheritedValue(), pool_gatherer, pool_gatherer_size))
+      ERROR("void cxios_get_filegroup_pool_gatherer(filegroup_Ptr filegroup_hdl, char * pool_gatherer, int pool_gatherer_size)", << "Input string is too short");
+    CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_filegroup_pool_gatherer(filegroup_Ptr filegroup_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = filegroup_hdl->pool_gatherer.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
+  void cxios_set_filegroup_pool_reader(filegroup_Ptr filegroup_hdl, const char * pool_reader, int pool_reader_size)
+  {
+    std::string pool_reader_str;
+    if (!cstr2string(pool_reader, pool_reader_size, pool_reader_str)) return;
+    CTimer::get("XIOS").resume();
+    filegroup_hdl->pool_reader.setValue(pool_reader_str);
+    CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_filegroup_pool_reader(filegroup_Ptr filegroup_hdl, char * pool_reader, int pool_reader_size)
+  {
+    CTimer::get("XIOS").resume();
+    if (!string_copy(filegroup_hdl->pool_reader.getInheritedValue(), pool_reader, pool_reader_size))
+      ERROR("void cxios_get_filegroup_pool_reader(filegroup_Ptr filegroup_hdl, char * pool_reader, int pool_reader_size)", << "Input string is too short");
+    CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_filegroup_pool_reader(filegroup_Ptr filegroup_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = filegroup_hdl->pool_reader.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
+  void cxios_set_filegroup_pool_writer(filegroup_Ptr filegroup_hdl, const char * pool_writer, int pool_writer_size)
+  {
+    std::string pool_writer_str;
+    if (!cstr2string(pool_writer, pool_writer_size, pool_writer_str)) return;
+    CTimer::get("XIOS").resume();
+    filegroup_hdl->pool_writer.setValue(pool_writer_str);
+    CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_filegroup_pool_writer(filegroup_Ptr filegroup_hdl, char * pool_writer, int pool_writer_size)
+  {
+    CTimer::get("XIOS").resume();
+    if (!string_copy(filegroup_hdl->pool_writer.getInheritedValue(), pool_writer, pool_writer_size))
+      ERROR("void cxios_get_filegroup_pool_writer(filegroup_Ptr filegroup_hdl, char * pool_writer, int pool_writer_size)", << "Input string is too short");
+    CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_filegroup_pool_writer(filegroup_Ptr filegroup_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = filegroup_hdl->pool_writer.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
   void cxios_set_filegroup_read_metadata_par(filegroup_Ptr filegroup_hdl, bool read_metadata_par)
   {
@@ -471,4 +575,30 @@
      CTimer::get("XIOS").resume();
      bool isDefined = filegroup_hdl->read_metadata_par.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
+  void cxios_set_filegroup_reader(filegroup_Ptr filegroup_hdl, const char * reader, int reader_size)
+  {
+    std::string reader_str;
+    if (!cstr2string(reader, reader_size, reader_str)) return;
+    CTimer::get("XIOS").resume();
+    filegroup_hdl->reader.setValue(reader_str);
+    CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_filegroup_reader(filegroup_Ptr filegroup_hdl, char * reader, int reader_size)
+  {
+    CTimer::get("XIOS").resume();
+    if (!string_copy(filegroup_hdl->reader.getInheritedValue(), reader, reader_size))
+      ERROR("void cxios_get_filegroup_reader(filegroup_Ptr filegroup_hdl, char * reader, int reader_size)", << "Input string is too short");
+    CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_filegroup_reader(filegroup_Ptr filegroup_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = filegroup_hdl->reader.hasInheritedValue();
      CTimer::get("XIOS").suspend();
      return isDefined;
@@ -911,4 +1041,27 @@
 
 
+  void cxios_set_filegroup_using_server2(filegroup_Ptr filegroup_hdl, bool using_server2)
+  {
+    CTimer::get("XIOS").resume();
+    filegroup_hdl->using_server2.setValue(using_server2);
+    CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_filegroup_using_server2(filegroup_Ptr filegroup_hdl, bool* using_server2)
+  {
+    CTimer::get("XIOS").resume();
+    *using_server2 = filegroup_hdl->using_server2.getInheritedValue();
+    CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_filegroup_using_server2(filegroup_Ptr filegroup_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = filegroup_hdl->using_server2.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
   void cxios_set_filegroup_uuid_format(filegroup_Ptr filegroup_hdl, const char * uuid_format, int uuid_format_size)
   {
@@ -961,3 +1114,29 @@
      return isDefined;
   }
+
+
+  void cxios_set_filegroup_writer(filegroup_Ptr filegroup_hdl, const char * writer, int writer_size)
+  {
+    std::string writer_str;
+    if (!cstr2string(writer, writer_size, writer_str)) return;
+    CTimer::get("XIOS").resume();
+    filegroup_hdl->writer.setValue(writer_str);
+    CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_filegroup_writer(filegroup_Ptr filegroup_hdl, char * writer, int writer_size)
+  {
+    CTimer::get("XIOS").resume();
+    if (!string_copy(filegroup_hdl->writer.getInheritedValue(), writer, writer_size))
+      ERROR("void cxios_get_filegroup_writer(filegroup_Ptr filegroup_hdl, char * writer, int writer_size)", << "Input string is too short");
+    CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_filegroup_writer(filegroup_Ptr filegroup_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = filegroup_hdl->writer.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
 }
Index: XIOS3/trunk/src/interface/c_attr/icredistribute_axis_attr.cpp
===================================================================
--- XIOS3/trunk/src/interface/c_attr/icredistribute_axis_attr.cpp	(revision 2616)
+++ XIOS3/trunk/src/interface/c_attr/icredistribute_axis_attr.cpp	(revision 2616)
@@ -0,0 +1,93 @@
+/* ************************************************************************** *
+ *               Interface auto generated - do not modify                     *
+ * ************************************************************************** */
+
+#include <boost/multi_array.hpp>
+#include "xios.hpp"
+#include "attribute_template.hpp"
+#include "object_template.hpp"
+#include "group_template.hpp"
+#include "icutil.hpp"
+#include "icdate.hpp"
+#include "timer.hpp"
+#include "node_type.hpp"
+
+extern "C"
+{
+  typedef xios::CRedistributeAxis* redistribute_axis_Ptr;
+
+  void cxios_set_redistribute_axis_index(redistribute_axis_Ptr redistribute_axis_hdl, int* index, int* extent)
+  {
+    CTimer::get("XIOS").resume();
+    CArray<int,1> tmp(index, shape(extent[0]), neverDeleteData);
+    redistribute_axis_hdl->index.reference(tmp.copy());
+     CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_redistribute_axis_index(redistribute_axis_Ptr redistribute_axis_hdl, int* index, int* extent)
+  {
+    CTimer::get("XIOS").resume();
+    CArray<int,1> tmp(index, shape(extent[0]), neverDeleteData);
+    tmp=redistribute_axis_hdl->index.getInheritedValue();
+     CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_redistribute_axis_index(redistribute_axis_Ptr redistribute_axis_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = redistribute_axis_hdl->index.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
+  void cxios_set_redistribute_axis_mask(redistribute_axis_Ptr redistribute_axis_hdl, bool* mask, int* extent)
+  {
+    CTimer::get("XIOS").resume();
+    CArray<bool,1> tmp(mask, shape(extent[0]), neverDeleteData);
+    redistribute_axis_hdl->mask.reference(tmp.copy());
+     CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_redistribute_axis_mask(redistribute_axis_Ptr redistribute_axis_hdl, bool* mask, int* extent)
+  {
+    CTimer::get("XIOS").resume();
+    CArray<bool,1> tmp(mask, shape(extent[0]), neverDeleteData);
+    tmp=redistribute_axis_hdl->mask.getInheritedValue();
+     CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_redistribute_axis_mask(redistribute_axis_Ptr redistribute_axis_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = redistribute_axis_hdl->mask.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
+  void cxios_set_redistribute_axis_type(redistribute_axis_Ptr redistribute_axis_hdl, const char * type, int type_size)
+  {
+    std::string type_str;
+    if (!cstr2string(type, type_size, type_str)) return;
+    CTimer::get("XIOS").resume();
+    redistribute_axis_hdl->type.fromString(type_str);
+    CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_redistribute_axis_type(redistribute_axis_Ptr redistribute_axis_hdl, char * type, int type_size)
+  {
+    CTimer::get("XIOS").resume();
+    if (!string_copy(redistribute_axis_hdl->type.getInheritedStringValue(), type, type_size))
+      ERROR("void cxios_get_redistribute_axis_type(redistribute_axis_Ptr redistribute_axis_hdl, char * type, int type_size)", << "Input string is too short");
+    CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_redistribute_axis_type(redistribute_axis_Ptr redistribute_axis_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = redistribute_axis_hdl->type.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+}
Index: XIOS3/trunk/src/interface/c_attr/icredistribute_domain_attr.cpp
===================================================================
--- XIOS3/trunk/src/interface/c_attr/icredistribute_domain_attr.cpp	(revision 2616)
+++ XIOS3/trunk/src/interface/c_attr/icredistribute_domain_attr.cpp	(revision 2616)
@@ -0,0 +1,93 @@
+/* ************************************************************************** *
+ *               Interface auto generated - do not modify                     *
+ * ************************************************************************** */
+
+#include <boost/multi_array.hpp>
+#include "xios.hpp"
+#include "attribute_template.hpp"
+#include "object_template.hpp"
+#include "group_template.hpp"
+#include "icutil.hpp"
+#include "icdate.hpp"
+#include "timer.hpp"
+#include "node_type.hpp"
+
+extern "C"
+{
+  typedef xios::CRedistributeDomain* redistribute_domain_Ptr;
+
+  void cxios_set_redistribute_domain_index(redistribute_domain_Ptr redistribute_domain_hdl, int* index, int* extent)
+  {
+    CTimer::get("XIOS").resume();
+    CArray<int,1> tmp(index, shape(extent[0]), neverDeleteData);
+    redistribute_domain_hdl->index.reference(tmp.copy());
+     CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_redistribute_domain_index(redistribute_domain_Ptr redistribute_domain_hdl, int* index, int* extent)
+  {
+    CTimer::get("XIOS").resume();
+    CArray<int,1> tmp(index, shape(extent[0]), neverDeleteData);
+    tmp=redistribute_domain_hdl->index.getInheritedValue();
+     CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_redistribute_domain_index(redistribute_domain_Ptr redistribute_domain_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = redistribute_domain_hdl->index.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
+  void cxios_set_redistribute_domain_mask(redistribute_domain_Ptr redistribute_domain_hdl, bool* mask, int* extent)
+  {
+    CTimer::get("XIOS").resume();
+    CArray<bool,1> tmp(mask, shape(extent[0]), neverDeleteData);
+    redistribute_domain_hdl->mask.reference(tmp.copy());
+     CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_redistribute_domain_mask(redistribute_domain_Ptr redistribute_domain_hdl, bool* mask, int* extent)
+  {
+    CTimer::get("XIOS").resume();
+    CArray<bool,1> tmp(mask, shape(extent[0]), neverDeleteData);
+    tmp=redistribute_domain_hdl->mask.getInheritedValue();
+     CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_redistribute_domain_mask(redistribute_domain_Ptr redistribute_domain_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = redistribute_domain_hdl->mask.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
+  void cxios_set_redistribute_domain_type(redistribute_domain_Ptr redistribute_domain_hdl, const char * type, int type_size)
+  {
+    std::string type_str;
+    if (!cstr2string(type, type_size, type_str)) return;
+    CTimer::get("XIOS").resume();
+    redistribute_domain_hdl->type.fromString(type_str);
+    CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_redistribute_domain_type(redistribute_domain_Ptr redistribute_domain_hdl, char * type, int type_size)
+  {
+    CTimer::get("XIOS").resume();
+    if (!string_copy(redistribute_domain_hdl->type.getInheritedStringValue(), type, type_size))
+      ERROR("void cxios_get_redistribute_domain_type(redistribute_domain_Ptr redistribute_domain_hdl, char * type, int type_size)", << "Input string is too short");
+    CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_redistribute_domain_type(redistribute_domain_Ptr redistribute_domain_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = redistribute_domain_hdl->type.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+}
Index: XIOS3/trunk/src/interface/c_attr/icredistribute_scalar_attr.cpp
===================================================================
--- XIOS3/trunk/src/interface/c_attr/icredistribute_scalar_attr.cpp	(revision 2616)
+++ XIOS3/trunk/src/interface/c_attr/icredistribute_scalar_attr.cpp	(revision 2616)
@@ -0,0 +1,93 @@
+/* ************************************************************************** *
+ *               Interface auto generated - do not modify                     *
+ * ************************************************************************** */
+
+#include <boost/multi_array.hpp>
+#include "xios.hpp"
+#include "attribute_template.hpp"
+#include "object_template.hpp"
+#include "group_template.hpp"
+#include "icutil.hpp"
+#include "icdate.hpp"
+#include "timer.hpp"
+#include "node_type.hpp"
+
+extern "C"
+{
+  typedef xios::CRedistributeScalar* redistribute_scalar_Ptr;
+
+  void cxios_set_redistribute_scalar_index(redistribute_scalar_Ptr redistribute_scalar_hdl, int* index, int* extent)
+  {
+    CTimer::get("XIOS").resume();
+    CArray<int,1> tmp(index, shape(extent[0]), neverDeleteData);
+    redistribute_scalar_hdl->index.reference(tmp.copy());
+     CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_redistribute_scalar_index(redistribute_scalar_Ptr redistribute_scalar_hdl, int* index, int* extent)
+  {
+    CTimer::get("XIOS").resume();
+    CArray<int,1> tmp(index, shape(extent[0]), neverDeleteData);
+    tmp=redistribute_scalar_hdl->index.getInheritedValue();
+     CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_redistribute_scalar_index(redistribute_scalar_Ptr redistribute_scalar_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = redistribute_scalar_hdl->index.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
+  void cxios_set_redistribute_scalar_mask(redistribute_scalar_Ptr redistribute_scalar_hdl, bool* mask, int* extent)
+  {
+    CTimer::get("XIOS").resume();
+    CArray<bool,1> tmp(mask, shape(extent[0]), neverDeleteData);
+    redistribute_scalar_hdl->mask.reference(tmp.copy());
+     CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_redistribute_scalar_mask(redistribute_scalar_Ptr redistribute_scalar_hdl, bool* mask, int* extent)
+  {
+    CTimer::get("XIOS").resume();
+    CArray<bool,1> tmp(mask, shape(extent[0]), neverDeleteData);
+    tmp=redistribute_scalar_hdl->mask.getInheritedValue();
+     CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_redistribute_scalar_mask(redistribute_scalar_Ptr redistribute_scalar_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = redistribute_scalar_hdl->mask.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
+  void cxios_set_redistribute_scalar_type(redistribute_scalar_Ptr redistribute_scalar_hdl, const char * type, int type_size)
+  {
+    std::string type_str;
+    if (!cstr2string(type, type_size, type_str)) return;
+    CTimer::get("XIOS").resume();
+    redistribute_scalar_hdl->type.fromString(type_str);
+    CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_redistribute_scalar_type(redistribute_scalar_Ptr redistribute_scalar_hdl, char * type, int type_size)
+  {
+    CTimer::get("XIOS").resume();
+    if (!string_copy(redistribute_scalar_hdl->type.getInheritedStringValue(), type, type_size))
+      ERROR("void cxios_get_redistribute_scalar_type(redistribute_scalar_Ptr redistribute_scalar_hdl, char * type, int type_size)", << "Input string is too short");
+    CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_redistribute_scalar_type(redistribute_scalar_Ptr redistribute_scalar_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = redistribute_scalar_hdl->type.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+}
Index: XIOS3/trunk/src/interface/fortran/iredistribute_axis.F90
===================================================================
--- XIOS3/trunk/src/interface/fortran/iredistribute_axis.F90	(revision 2616)
+++ XIOS3/trunk/src/interface/fortran/iredistribute_axis.F90	(revision 2616)
@@ -0,0 +1,30 @@
+#include "xios_fortran_prefix.hpp"
+
+MODULE IREDISTRIBUTE_AXIS
+   USE, INTRINSIC :: ISO_C_BINDING
+   USE REDISTRIBUTE_AXIS_INTERFACE
+
+   TYPE txios(redistribute_axis)
+      INTEGER(kind = C_INTPTR_T) :: daddr
+   END TYPE txios(redistribute_axis)
+
+   CONTAINS ! Fonctions disponibles pour les utilisateurs.
+
+   SUBROUTINE xios(get_redistribute_axis_handle)(idt,ret)
+      IMPLICIT NONE
+      CHARACTER(len = *), INTENT(IN) :: idt
+      TYPE(txios(redistribute_axis)) , INTENT(OUT):: ret
+      CALL cxios_redistribute_axis_handle_create(ret%daddr, idt, len(idt))
+   END SUBROUTINE xios(get_redistribute_axis_handle)
+
+   LOGICAL FUNCTION xios(is_valid_redistribute_axis)(idt)
+      IMPLICIT NONE
+      CHARACTER(len  = *)    , INTENT(IN) :: idt
+      LOGICAL  (kind = 1)                 :: val
+
+      CALL cxios_redistribute_axis_valid_id(val, idt, len(idt))
+      xios(is_valid_redistribute_axis) = val
+
+   END FUNCTION  xios(is_valid_redistribute_axis)
+
+END MODULE IREDISTRIBUTE_AXIS
Index: XIOS3/trunk/src/interface/fortran/iredistribute_domain.F90
===================================================================
--- XIOS3/trunk/src/interface/fortran/iredistribute_domain.F90	(revision 2616)
+++ XIOS3/trunk/src/interface/fortran/iredistribute_domain.F90	(revision 2616)
@@ -0,0 +1,30 @@
+#include "xios_fortran_prefix.hpp"
+
+MODULE IREDISTRIBUTE_DOMAIN
+   USE, INTRINSIC :: ISO_C_BINDING
+   USE REDISTRIBUTE_DOMAIN_INTERFACE
+
+   TYPE txios(redistribute_domain)
+      INTEGER(kind = C_INTPTR_T) :: daddr
+   END TYPE txios(redistribute_domain)
+
+   CONTAINS ! Fonctions disponibles pour les utilisateurs.
+
+   SUBROUTINE xios(get_redistribute_domain_handle)(idt,ret)
+      IMPLICIT NONE
+      CHARACTER(len = *), INTENT(IN) :: idt
+      TYPE(txios(redistribute_domain)) , INTENT(OUT):: ret
+      CALL cxios_redistribute_domain_handle_create(ret%daddr, idt, len(idt))
+   END SUBROUTINE xios(get_redistribute_domain_handle)
+
+   LOGICAL FUNCTION xios(is_valid_redistribute_domain)(idt)
+      IMPLICIT NONE
+      CHARACTER(len  = *)    , INTENT(IN) :: idt
+      LOGICAL  (kind = 1)                 :: val
+
+      CALL cxios_redistribute_domain_valid_id(val, idt, len(idt))
+      xios(is_valid_redistribute_domain) = val
+
+   END FUNCTION  xios(is_valid_redistribute_domain)
+
+END MODULE IREDISTRIBUTE_DOMAIN
Index: XIOS3/trunk/src/interface/fortran/iredistribute_scalar.F90
===================================================================
--- XIOS3/trunk/src/interface/fortran/iredistribute_scalar.F90	(revision 2616)
+++ XIOS3/trunk/src/interface/fortran/iredistribute_scalar.F90	(revision 2616)
@@ -0,0 +1,30 @@
+#include "xios_fortran_prefix.hpp"
+
+MODULE IREDISTRIBUTE_SCALAR
+   USE, INTRINSIC :: ISO_C_BINDING
+   USE REDISTRIBUTE_SCALAR_INTERFACE
+
+   TYPE txios(redistribute_scalar)
+      INTEGER(kind = C_INTPTR_T) :: daddr
+   END TYPE txios(redistribute_scalar)
+
+   CONTAINS ! Fonctions disponibles pour les utilisateurs.
+
+   SUBROUTINE xios(get_redistribute_scalar_handle)(idt,ret)
+      IMPLICIT NONE
+      CHARACTER(len = *), INTENT(IN) :: idt
+      TYPE(txios(redistribute_scalar)) , INTENT(OUT):: ret
+      CALL cxios_redistribute_scalar_handle_create(ret%daddr, idt, len(idt))
+   END SUBROUTINE xios(get_redistribute_scalar_handle)
+
+   LOGICAL FUNCTION xios(is_valid_redistribute_scalar)(idt)
+      IMPLICIT NONE
+      CHARACTER(len  = *)    , INTENT(IN) :: idt
+      LOGICAL  (kind = 1)                 :: val
+
+      CALL cxios_redistribute_scalar_valid_id(val, idt, len(idt))
+      xios(is_valid_redistribute_scalar) = val
+
+   END FUNCTION  xios(is_valid_redistribute_scalar)
+
+END MODULE IREDISTRIBUTE_SCALAR
